int tmpnotes[] = {43, 81, 147, 272, 514, 971, 1834, 3733};

#define c 261
#define d 294
#define e 329
#define f 349
#define g 392
#define a 440
#define b 493
#define C 523

int intTime = 250;

// change this to make the song slower or faster
int tempo = 200;

int melody1[] = {
  c, d, e, f, g, a, b, C,
  //  c, c, g, g, a, a, g,
  //  f, f, e, e, d, d, c,
  //  f, f, g, g, e, e, d,
  //  g, g, f, f, e, e, d,
  //  c, c, g, g, a, a, g,
  //  f, f, e, e, d, d, c,

};

int melody2[] = {
//  c, d, e, f, g, a, b, C,
    c, c, g, g, a, a, g,
    f, f, e, e, d, d, c,
    f, f, g, g, e, e, d,
    g, g, f, f, e, e, d,
    c, c, g, g, a, a, g,
    f, f, e, e, d, d, c,

};
int melodyIndex = 0;
int *melody = melody1;
// sizeof gives the number of bytes, each int value is composed of two bytes (16 bits)
// there are two values per note (pitch and duration), so for each note there are four bytes
int notes = sizeof(melody) / sizeof(melody[0]) / 2;

// this calculates the duration of a whole note in ms
int wholenote = (60000 * 4) / tempo;

int divider = 0, noteDuration = 0;

int thisNote = 0;

int DO = A0;
int RE = A1;
int MI = A2;
int FA = A3;
int SO = A4;
int LA = A5;
int SI = 2;
int DO2 = 3;


int ledDO = 5;
int ledRE = 6;
int ledMI = 7;
int ledFA = 8;
int ledSO = 9;
int ledLA = 10;
int ledSI = 11;
int ledDO2 = 12;
int buzzer = 13;

int mode = 0;

void pciSetup(byte pin)
{
  *digitalPinToPCMSK(pin) |= bit (digitalPinToPCMSKbit(pin));  // enable pin
  PCIFR  |= bit (digitalPinToPCICRbit(pin)); // clear any outstanding interrupt
  PCICR  |= bit (digitalPinToPCICRbit(pin)); // enable interrupt for the group
}

ISR (PCINT0_vect)
{
  static unsigned long last_interrupt_time = 0;
  unsigned long interrupt_time = millis();
  if (interrupt_time - last_interrupt_time > intTime) {

  }
  last_interrupt_time = interrupt_time;

}
ISR (PCINT1_vect)
{
  static unsigned long last_interrupt_time = 0;
  unsigned long interrupt_time = millis();
  if (interrupt_time - last_interrupt_time > intTime) {
    int n1 = digitalRead(DO);
    int n2 = digitalRead(RE);
    int n3 = digitalRead(MI);
    int n4 = digitalRead(FA);
    int n5 = digitalRead(SO);
    int n6 = digitalRead(LA);
    thisNote++;
    if (n1 == HIGH) {
      tone(buzzer, c, 300);
    } else if (n2 == HIGH) {
      tone(buzzer, d, 300);
    } else if (n3 == HIGH) {
      tone(buzzer, e, 300);
    } else if (n4 == HIGH) {
      tone(buzzer, f, 300);
    } else if (n5 == HIGH) {
      tone(buzzer, g, 300);
    } else if (n6 == HIGH) {
      tone(buzzer, a, 300);
    }
  }
  last_interrupt_time = interrupt_time;

}
ISR (PCINT2_vect)
{
  static unsigned long last_interrupt_time = 0;
  unsigned long interrupt_time = millis();
  if (interrupt_time - last_interrupt_time > intTime) {
    int n1 = digitalRead(SI);
    int n2 = digitalRead(DO2);
    thisNote++;
    int m = digitalRead(4);
    int song = digitalRead(1);
    if (n1 == HIGH) {
      tone(buzzer, b, 300);
    } else if (n2 == HIGH) {
      tone(buzzer, C, 300);
    } else if (m == HIGH) {
      if (mode == 0) {
        melodyIndex = 0;
        thisNote = 0;
        mode = 1;
      } else {
        mode = 0;
      }
    } else if(song == HIGH) {
      thisNote = 0;
      if(melodyIndex < 1){
        melodyIndex++;
      } else {
        melodyIndex = 0;
      }
      if(melodyIndex == 0) {
        melody = melody1;
      } else {
        melody = melody2;
      }
    }
  }
  last_interrupt_time = interrupt_time;
}

void setup()
{
  pciSetup(DO);
  pciSetup(RE);
  pciSetup(MI);
  pciSetup(FA);
  pciSetup(SO);
  pciSetup(LA);
  pciSetup(SI);
  pciSetup(DO2);
  pciSetup(4);
  pciSetup(1);

}

void loop()
{
  int nota = melody[thisNote];
  if(mode == 1) {
    if (nota == c) {
      PORTD |= (1 << PD5);
      PORTD &= ~(1 << PD6);
      PORTD &= ~(1 << PD7);
      //    PORTD &= ~(1 << PB0);
      digitalWrite(8, LOW);
      PORTB &= ~(1 << PB1);
      PORTB &= ~(1 << PB2);
      PORTB &= ~(1 << PB3);
      PORTB &= ~(1 << PB4);
    } else if (nota == d) {
      PORTD &= ~(1 << PD5);
      PORTD |= (1 << PD6);
      PORTD &= ~(1 << PD7);
      //    PORTD &= ~(1 << PB0);
      digitalWrite(8, LOW);
      PORTB &= ~(1 << PB1);
      PORTB &= ~(1 << PB2);
      PORTB &= ~(1 << PB3);
      PORTB &= ~(1 << PB4);
    } else if (nota == e) {
      PORTD &= ~(1 << PD5);
      PORTD &= ~(1 << PD6);
      PORTD |= (1 << PD7);
      //    PORTD &= ~(1 << PB0);
      digitalWrite(8, LOW);
      PORTB &= ~(1 << PB1);
      PORTB &= ~(1 << PB2);
      PORTB &= ~(1 << PB3);
      PORTB &= ~(1 << PB4);
    } else if (nota == f) {
      PORTD &= ~(1 << PD5);
      PORTD &= ~(1 << PD6);
      PORTD &= ~(1 << PD7);
      //    PORTD |= (1 << PB0);
      digitalWrite(8, HIGH);
      PORTB &= ~(1 << PB1);
      PORTB &= ~(1 << PB2);
      PORTB &= ~(1 << PB3);
      PORTB &= ~(1 << PB4);
    } else if (nota == g) {
      PORTD &= ~(1 << PD5);
      PORTD &= ~(1 << PD6);
      PORTD &= ~(1 << PD7);
      //    PORTD &= ~(1 << PB0);
      digitalWrite(8, LOW);
      PORTB |= (1 << PB1);
      PORTB &= ~(1 << PB2);
      PORTB &= ~(1 << PB3);
      PORTB &= ~(1 << PB4);
    } else if (nota == a) {
      PORTD &= ~(1 << PD5);
      PORTD &= ~(1 << PD6);
      PORTD &= ~(1 << PD7);
      //    PORTD &= ~(1 << PB0);
      digitalWrite(8, LOW);
      PORTB &= ~(1 << PB1);
      PORTB |= (1 << PB2);
      PORTB &= ~(1 << PB3);
      PORTB &= ~(1 << PB4);
    } else if (nota == b) {
      PORTD &= ~(1 << PD5);
      PORTD &= ~(1 << PD6);
      PORTD &= ~(1 << PD7);
      //    PORTD &= ~(1 << PB0);
      digitalWrite(8, LOW);
      PORTB &= ~(1 << PB1);
      PORTB &= ~(1 << PB2);
      PORTB |= (1 << PB3);
      PORTB &= ~(1 << PB4);
    } else if (nota == C) {
      PORTD &= ~(1 << PD5);
      PORTD &= ~(1 << PD6);
      PORTD &= ~(1 << PD7);
      //    PORTD &= ~(1 << PB0);
      digitalWrite(8, LOW);
      PORTB &= ~(1 << PB1);
      PORTB &= ~(1 << PB2);
      PORTB &= ~(1 << PB3);
      PORTB |= (1 << PB4);
    } else {
      thisNote = 0;
      PORTD &= ~(1 << PD5);
      PORTD &= ~(1 << PD6);
      PORTD &= ~(1 << PD7);
      //    PORTD &= ~(1 << PB0);
      digitalWrite(8, LOW);
      PORTB &= ~(1 << PB1);
      PORTB &= ~(1 << PB2);
      PORTB &= ~(1 << PB3);
      PORTB &= ~(1 << PB4);
    }
  } else {
    PORTD &= ~(1 << PD5);
      PORTD &= ~(1 << PD6);
      PORTD &= ~(1 << PD7);
      //    PORTD &= ~(1 << PB0);
      digitalWrite(8, LOW);
      PORTB &= ~(1 << PB1);
      PORTB &= ~(1 << PB2);
      PORTB &= ~(1 << PB3);
      PORTB &= ~(1 << PB4);
  }
}
